<?php

	$file = 'image.webp';

	function data_as_str($data)
	{
		if(is_array($data))
		{
			$res='';
			foreach($data as $d)
			{
				$res.=($res!=''?', ':'').data_as_str($d);
			}
			return $res;
		}
		else
		{
			if(isset($data))
			{
				return trim((string)$data);
			}
			else
			{
				return '';
			}
		}
	}


	$choice=[];
	if ($webp_fp = @fopen('./'.$file, 'rb'))
	{
		$webp_header = @unpack('a4riff/I1size/a4webp', fread($webp_fp, 12));
		if (($webp_header['riff']=='RIFF') and ($webp_header['webp']=='WEBP')) // required WebP header
		{
			$exif_found=false;
			echo '<form method="post">';
			while(!feof($webp_fp))
			{
				$chunk_info = @unpack('a4type/I1size', fread($webp_fp, 8));
				if(!$chunk_info)
				{
					break;
				}
				if($chunk_info['type'] == 'EXIF')
				{
					$chunk_data = fread($webp_fp, $chunk_info['size']); // read EXIF chunk from image
					$php_mem  = fopen('php://memory', 'w+'); // create php memory stream
					fputs($php_mem, $chunk_data);
					rewind($php_mem);
					$exif=@exif_read_data($php_mem, null, true);
					fclose($php_mem);
					
					
//					echo'<pre>'.print_r($exif, true).'</pre>';exit; // todo
					
					
					echo '-----------------------------------<br><br>';
					foreach($exif as $key=>$data)
					{
						echo '<b>'.$key.'</b><br>';
						foreach($data as $k=>$id)
						{
							$exif_found=true;
							$box_id=$key.'_'.$k;
							$checked='';
							if (isset($_POST[$box_id]) and ($_POST[$box_id]=='c'))
							{
								$checked='checked ';
								$choice[$key][]=$k;
							}
							echo '&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" id="'.$box_id.'" name="'.$box_id.'" '.$checked.'value="c"><b>'.$k.'</b> = '.data_as_str($id).'<br>';
						}
						echo '<br>';
					}
					echo '-----------------------------------<br>';
					break; // stop searching as only one EXIF section is allowed
				}
				else
				{
					fseek($webp_fp, $chunk_info['size'], SEEK_CUR); // skip the chunk
				}
				if ($chunk_info['size'] & 1) // if chunk size is odd, skip the padding byte
				{
					fseek($webp_fp, 1, SEEK_CUR);
				}
			}
			fclose($webp_fp);
			echo '<br>';
			if($exif_found)
			{
				echo 'Generate WEB_EXIF configuration for Single File PHP Gallery.<br>Mark the wanted elements above and click Generate:<br><br><input type="submit" value="Generate"><br>';
			}
			else
			{
				echo 'Unable to find any EXIF information in the WebP file.';
			}
			echo '</form>';
		}
		else
		{	
			echo $file.' is not a valid WebP file.';
		}
	}
	else
	{
		echo 'Unable to open '.$file.'<br>Place a WebP image file called <b>'.$file.'</b> in this directory and refresh the page.';
	}

	if(count($choice)>0)
	{
		echo 'Copy the following to the Single File PHP Gallery script replacing the previous WEBP_EXIF option lines:<br>-------------------------------<pre>';
		echo "\toption('WEBP_EXIF', [<br>";

		foreach($choice as $key=>$data)
		{
			echo "\t\t'".$key."'=>[";
			foreach($data as $k)
			{
				echo "'".$k."', ";
			}
			echo '],<br>';
		}
		echo "\t]);";
		echo "</pre>-------------------------------";
	}

?>
